#include <iostream>
#include <vector>
#include <cstdlib> //rand, srand
#include <ctime> //time
#include <algorithm> //max_element

#include <iomanip> //debug
#include "graph/rgbcolor.h"
#include "graph/mingl.h"
#include "graph/pos.h"
#include "figs/rectangle.h"
#include "figs/figure.h"
#include "tools/pixelexception.h"


using namespace std;



typedef   vector <unsigned>  CVUInt;
size_t FindDichot (unsigned Val,
                  const CVUInt & Tab,
                  const size_t & Deb, const size_t & Fin)
{
    if (Fin - Deb < 1) return Fin;

    size_t PosDeb = Deb;
    size_t PosFin = Fin - 1;

    size_t Milieu;
    while (PosFin != PosDeb)
    {
        Milieu = (PosDeb + PosFin) / 2;

        if (Val > Tab [Milieu])
            PosDeb = Milieu + 1;
        else
            PosFin = Milieu;
    }
    return Val == Tab [PosDeb] ? PosDeb : Fin;

} // FindDichot()

void GenerPrimesInfEqN (CVUInt & LesPremiers, unsigned N)
{
//TODO
} // GenerPrimesInfEqN()

typedef  vector <CVUInt> matrix;
void draw (minGL &Window, const matrix & mat)
{
    //TODO
}

void UlamV1 (minGL &Window)
{

    const unsigned KSize (Window.getWindowWidth());

    const unsigned KNbElem = KSize * KSize;
    CVUInt LesPremiers;

    GenerPrimesInfEqN (LesPremiers, KNbElem);

    matrix mat;
    mat.resize(KSize);
    for (CVUInt & V : mat)
        V.resize(KSize);

    const unsigned Centre = KSize / 2;

    mat [Centre][Centre] = 1;

    for (unsigned N (1), Li (Centre), Col (Centre), NbParBoucle (2);
         N < KNbElem; )
    {
        ++Li;
        ++Col;
        for (unsigned i = 0; i < NbParBoucle; ++i)
            mat [--Li] [Col] = ++N;

        for (unsigned i = 0; i < NbParBoucle; ++i)
            mat [Li] [--Col] = ++N;

        for (unsigned i = 0; i < NbParBoucle; ++i)
            mat [++Li] [Col] = ++N;

        for (unsigned i = 0; i < NbParBoucle; ++i)
            mat [Li] [++Col] = ++N;

       NbParBoucle += 2;
    }


    /*        * /
    // Affichage des nombres premiers

    for (Ind_t j = 0; j < Nb1ers; ++j)
    {
        cout << setw (6) << LesPremiers [j];
        if (0 == (j + 1) % 10) cout << '\n';
    }
    cout << '\n';

    /*         */

    // Suppression des non premiers

    //TODO

    /*        * /
    // Affichage de la matrice finale


    for (unsigned i = 0; i < KSize; ++i)
    {
        for (unsigned j = 0; j < KSize; ++j)
            if (0 == mat [i][j])
                cout << setw (4) << ' ';
            else
                cout << setw (4) << mat [i] [j];
        cout << '\n';
    }
    cout << '\n';

    /*         */
    // Generation de l'image

    draw (Window, mat);
} // UlamV1()

int main()
{

    cout << "Spirale d'Ulam - V1\n\n";

    unsigned Size;
    cout << "Taille du carre : ";
    cin >> Size;

    minGL Window (Size + 2, Size+ 2, "ULAM");
    Window.initGlut();
    Window.initGraphic();
    UlamV1(Window);
    Window.updateGraphic();
    Window.get_key();


    return 0;
}
